/*!
 * Bosch Messtechnik
 * kittelberger.de / dsp
 * 20151014
 */



$(document).ready(function() {

    var $page = $('#page');



    $('.hover-row')
        .on('mouseenter', function() {
            $(this).addClass('active');
        })
        .on('mouseleave', function() {
            $(this).removeClass('active');
            $(this).removeClass('clicked');
        });

    $('.hover-row.rotating').on('click', function() {
        $(this).toggleClass('clicked');
    });



    // Cycle 2 Slideshow: Events
    var textContainer = $('#item-text');
    $('.cycle-slideshow').on('cycle-before', function(event, opts) {
        var activeItemText = $('.cycle-slide-active').attr('data-claim');
        textContainer.html('');
    });
    $('.cycle-slideshow').on('cycle-after', function(event, opts) {
        var activeItemText = $('.cycle-slide-active').attr('data-claim');
        //console.log(activeItemText);
        textContainer.html(activeItemText);
    });



    // check if current page is anwendungen.html
    if (window.location.href.indexOf("anwendungen.html") > -1) {
        // force reload if same URL and URL with hash
        $("#navigation-wrapper a[href*='#app-']").click(function() {
            window.location.href = $(this).attr("href");
            window.location.reload(true);
            return false;
        });
    }

    parseHashFromApplication = function() {
        var hash = window.location.hash.substr(1);
        if (hash.length > 1) {
            value = 1 * (hash.replace("app-", ""));
            if ($.isNumeric(value)) {
                //update slideshow with param passed through hash number
                $('.cycle-slideshow').cycle('goto', value);
            };
        };
    };

    $(window).on('load', function() {
        parseHashFromApplication();
    });



    // fancybox customs
    $(".fancybox-clickarea").click(function() {
        $(this).find('.fbtrigger').click();
    });
    $('.mobile-navigation .row-offcanvas.row-offcanvas-left').on('click', function() {
        console.log('navbar clicked');
        $(this).toggleClass('active');
    });

    // controlpanel for video on mobile devices
    var screenW = $(window).width();
    if (screenW < 767) {
        $('#video').attr('controls', 'controls');
    }



    // vertical align middle
    $(window).on('load', function() {
        $('.vertical-middle').each(function(i) {
            var element = $(this);
            var parent = $(this).closest('.vertical-middle-parent');
            var pH = parent.outerHeight(true);
            var eH = element.outerHeight(true);
            var mT = (pH - eH) / 2;
            if (mT > 0) {
                element.css('top', 0);
                element.css('margin-top', mT + 'px');
            };
        });
        $('.vertical-middle .icon').each(function(i) {
            var element = $(this);
            var parent = $(this).closest('.vertical-middle');
            var pH = parent.height();
            var eH = element.height();
            var mT = (pH - eH) / 2;
            if (mT > 0) {
                element.css('top', 0);
                element.css('margin-top', mT + 'px');
            };
        });
    });



    $(window).on('resize', function() {
        $('.vertical-middle').each(function(i) {
            var element = $(this);
            var parent = $(this).closest('.vertical-middle-parent');
            var pH = parent.height();
            var eH = element.height();
            var mT = (pH - eH) / 2;
            if (mT > 0) {
                element.css('top', 0);
                element.css('margin-top', mT + 'px');
            };
        });
        $('.vertical-middle .icon').each(function(i) {
            var element = $(this);
            var parent = $(this).closest('.vertical-middle');
            var pH = parent.height();
            var eH = element.height();
            var mT = (pH - eH) / 2;
            if (mT > 0) {
                element.css('top', 0);
                element.css('margin-top', mT + 'px');
            };
        });
    });




    var currentOS = function() {
        var userAgent = navigator.userAgent || navigator.vendor || window.opera;

        if (userAgent.match(/iPad/i) || userAgent.match(/iPhone/i) || userAgent.match(/iPod/i)) {
            return 'ios';
        } else if (userAgent.match(/Android/i)) {
            return 'android';
        } else {
            return '';
        }
    };

    // set current device into body-class
    $('body').addClass(currentOS());

    // mobile navigation
    $('[data-toggle="offcanvas"]').click(function() {
        $('.row-offcanvas').toggleClass('active');
    });


    // desktop only function
    if ($(window).width() > 768) {
        // scroll to top
        $('#totop').on('click', function() {
            $.scrollTo('#scene-1', 1600, {
                easing: 'easeInOutCirc',
                onAfter: function() {
                    $.updateSceneDisplay();
                    bControllerLocked = false;
                }
            });
        });
    };

    // 20140730 workaround: prevents covering of bootstrap modals (caused by animate.css)
    var checkeventcount = 1,
        prevTarget;
    $('.modal').on('show.bs.modal', function(e) {
        if (typeof prevTarget == 'undefined' || (checkeventcount == 1 && e.target != prevTarget)) {
            prevTarget = e.target;
            checkeventcount++;
            e.preventDefault();
            $(e.target).appendTo('body').modal('show');
        } else if (e.target == prevTarget && checkeventcount == 2) {
            checkeventcount--;
        }
    });



    /**
     * Performance-Fix: stop html5 video loops when bootstrap modal opens
     */
    var $modals = $page.find('div.modal'),
        $videos = $page.find('video');

    if ($modals.length && $videos.length) {
        $modals
            .on('show.bs.modal', function() {
                $videos.each(function(i, el) {
                    el.pause();
                });
            })
            .on('hidden.bs.modal', function() {
                $videos.each(function(i, el) {
                    el.play();
                });
            });
    }
});

/* 20150703 dsp: quickndirty hack which closes the cookie-law modal, if user accepts cookies */
$(window).load(function() {
    var modal = $('#cookieInformation');
    var button = $('#cookieInformation .relatedItems.btns').eq(0);
    button.on('click', function() {
        modal.remove();
    });
});

/* START 20150708: if forwarded from the app and the hash '#faq-section' was found, than hide all other markup on ios */
var displayFaqSectionOnly = function() {
    if ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/Android/i))) {
        if (window.location.hash) {
            /*console.log('displayFaqSectionOnly()');*/
            var hash = window.location.hash.substring(1);
            if (hash === 'faq-section') {
                $('*').removeClass('wow');
                $('*').removeClass('bounceInUp');
                $('*').removeClass('animated');
                $('section').not('#faq-section').css('display', 'none');
                $('.visible-xs').attr('style', 'display:none !important');
                $('#faq-section').attr('style', 'position: absolute; margin-top:0 !important; top: 0; padding-top: 0;');
                $('#faq-section').attr('class', '');
                $('.page').css('height', '100%');
                $('body').append($('#faq-section'));
                $('#page').css('display', 'none');
                $('body').scrollTop(0);
            };
        };
    };
};
$(window).load(function() {
    displayFaqSectionOnly();
});
/* END 20150708 */

/* START 20150709 pko: NO-NO; SE-SV; FI-FI (index.html klick auf Buy Button scrollt auf #scene-10) */
$(document).ready(function() {
    $('.btn-buy').on('click', function(event) {
        event.preventDefault();
        $('body, html').animate({
            'scrollTop': $('#scene-10').offset().top
        }, 1200);
        $('#scene-10 .rotating').addClass('clicked');
    });
});
/* END 20150709 */

/* START Repositioning of dealer logos */
var reposDealerRows = function() {
    var parentcontainer = $('.backside.dealer-logo-wrapper').closest('.vertical-middle-parent');
    if (parentcontainer.length) {
        parentcontainer.each(function() {
            var zoomcontainerH = $(this).find('.zoom-container').height();
            var row = $(this).find('.row-dealer');
            var firstRow = $(this).find('.row-dealer').eq(0);
            var rowTotalH = 0;
            var tileMT = 0;
            row.each(function(i) {
                rowTotalH += $(this).height();
                console.log('rowHeight ' + i + ': ' + $(this).height());

            });
            tileMT = (zoomcontainerH - rowTotalH) / 2;
            console.log(tileMT);
            firstRow.css('padding-top', tileMT + 'px');
        });
    };
};

$(window).on({
    load: function() {
        reposDealerRows();
    },
    resize: function() {
        reposDealerRows();
    }
});
/* END Repositioning of dealer logos */

$(document).ready(function() {
    // Bind to the click of all links with a #hash in the href
    $('.ls-scroller a[href^="#"]').click(function(e) {
        // Prevent the jump and the #hash from appearing on the address bar
        e.preventDefault();
        // Scroll the window, stop any previous animation, stop on user manual scroll
        // Check https://github.com/flesler/jquery.scrollTo for more customizability
        $(window).stop(true).scrollTo(this.hash, {
            duration: 640,
            interrupt: false,
            offset: -92
        });
    });
    
});





// START back to top arrow 
$(document).ready(function() {
    // browser window scroll (in pixels) after which the "back to top" link is shown
    var offset = 300,
        //browser window scroll (in pixels) after which the "back to top" link opacity is reduced
        offset_opacity = 1200,
        //duration of the top scrolling animation (in ms)
        scroll_top_duration = 700,
        //grab the "back to top" link
        $back_to_top = $('.to-top');

    //hide or show the "back to top" link
    $(window).scroll(function() {
        ($(this).scrollTop() > offset) ? $back_to_top.addClass('to-is-visible'): $back_to_top.removeClass('to-is-visible to-fade-out');
        if ($(this).scrollTop() > offset_opacity) {
            $back_to_top.addClass('to-fade-out');
        }
    });

    //smooth scroll to top
    $back_to_top.on('click', function(event) {
        event.preventDefault();
        $('body,html').animate({
            scrollTop: 0,
        }, scroll_top_duration);
    });
});

/*
$(document).ready(function(e) {
    var subnavelms = $('.header-subnavigation .has-subnav');
    if (subnavelms.length) {
        subnavelms.each(function(index, element) {
      var nav = $('.header-subnavigation-level-2');
      var curnav = $('.header-subnavigation-level-2').eq(index);
            subnavelms.on ('mouseenter', function () {
                nav.removeClass('active');
                curnav.addClass('active');
            });
            subnavelms.on ('mouseleave', function () {
                nav.removeClass('active');
            });
    });
    };
});
*/

/* START sticky quicknavigation on scroll position */
var fixedQuickNavigation = function() {
    // check existance of .quicknavigation
    if ($('.header-subnavigation').length) {
        var w = $(window);
        var quicknavigation = $('.header-subnavigation');
        var quicksubnavigation = $('#header-subnavigation-level-2');
        var quicknavigationOffsetTop = quicknavigation.offset().top;
        w.scroll(function() {
            if (w.scrollTop() > quicknavigationOffsetTop) {
                quicknavigation.addClass('fixed');
                quicksubnavigation.addClass('fixed');
            } else {
                quicknavigation.removeClass('fixed');
                quicksubnavigation.removeClass('fixed');
            }
        });
    };
};
$(window).load(function() {
    fixedQuickNavigation();
});
/* END sticky quicknavigation on scroll position */


/* START faq section */
var initFaqSection = function() {
    if ($('.faq-section-listing').length) {
        var listitems = $('.faq-section-listing li');
        listitems.each(function(i) {
            $(this).on('click', function(event) {
                event.preventDefault();
                listitems.removeClass('active');
                $(this).addClass('active');
                $('#faq-answer .faq-answer-wrapper').removeClass('active');
                $('#faq-answer .faq-answer-wrapper').eq(i).addClass('active');
            });
        });
    };
};
$(window).load(function() {
    initFaqSection();
});
/* END faq section */

// TOOLTIPS
$(function() {
    var targets = $('[rel~=tooltip]'),
        target = false,
        tooltip = false,
        title = false;

    targets.bind('mouseenter', function() {
        target = $(this);
        tip = target.attr('title');
        tooltip = $('<div id="tooltip"></div>');

        if (!tip || tip === '')
            return false;

        target.removeAttr('title');
        tooltip.css('opacity', 0)
            .html(tip)
            .appendTo('body');

        var init_tooltip = function() {
            if ($(window).width() < tooltip.outerWidth() * 1.5)
                tooltip.css('max-width', $(window).width() / 2);
            else
                tooltip.css('max-width', 340);

            var pos_left = target.offset().left + (target.outerWidth() / 2) - (tooltip.outerWidth() / 2),
                pos_top = target.offset().top - tooltip.outerHeight() - 20;

            if (pos_left < 0) {
                pos_left = target.offset().left + target.outerWidth() / 2 - 20;
                tooltip.addClass('left');
            } else
                tooltip.removeClass('left');

            if (pos_left + tooltip.outerWidth() > $(window).width()) {
                pos_left = target.offset().left - tooltip.outerWidth() + target.outerWidth() / 2 + 20;
                tooltip.addClass('right');
            } else
                tooltip.removeClass('right');

            if (pos_top < 0) {
                var pos_top = target.offset().top + target.outerHeight();
                tooltip.addClass('top');
            } else
                tooltip.removeClass('top');

            tooltip.css({
                    left: pos_left,
                    top: pos_top
                })
                .animate({
                    top: '+=10',
                    opacity: 1
                }, 50);
        };

        init_tooltip();
        $(window).resize(init_tooltip);

        var remove_tooltip = function() {
            tooltip.animate({
                top: '-=10',
                opacity: 0
            }, 50, function() {
                $(this).remove();
            });

            target.attr('title', tip);
        };

        target.bind('mouseleave', remove_tooltip);
        tooltip.bind('click', remove_tooltip);
    });
});

// $.browser.mobile
var isMobile = {
    Android: function() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function() {
        return navigator.userAgent.match(/IEMobile/i) || navigator.userAgent.match(/WPDesktop/i);
    },
    any: function() {
        return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
    }
};

var viewMobile = function() {
    if ($('.hidden-tablet-desktop').is(":visible")) {
        return true
    } else return false
}

// MOBILE
$(document).ready(function() {
    $('.quicknavigation .scroll-nav .scroll-nav__heading').on('click', function() {
        $(this).closest('.scroll-nav__wrapper').find('.scroll-nav__list').toggleClass('open');
        $(this).closest('.scroll-nav__wrapper').find('.scroll-nav__heading').toggleClass('active');
    });
    $('.quicknavigation .scroll-nav .scroll-nav__list li').on('click', function() {
        $('.scroll-nav__list').removeClass('open');
        $('.scroll-nav__heading').removeClass('active');
    });

    if (isMobile.any()) {
        $(".carousel").swiperight(function() {
            $(this).carousel('prev');
        });
        $(".carousel").swipeleft(function() {
            $(this).carousel('next');
        });

        $('.carousel').on('slide.bs.carousel', function () {
            // do something…
            var currentSection = $(this).closest('.section');
            $('html,body').animate({scrollTop: currentSection.offset().top},'slow');
        });

        $(".button-wrapper").on("tap",function(event){
            event.preventDefault();
            $(".button-wrapper").removeClass('open');
            $(this).toggleClass('open');
        });
    }
});


